/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// TimeDuration Duration of a temporal extent expressed as a number scaled by a temporal unit
type TimeDuration interface {
	TimeTemporalDuration
	timeNumericDurationSinglefloat64
	timeUnitTypeSingleTimeTemporalUnit
	IsTimeDuration() bool // indicates base class
}

// sTimeDuration Duration of a temporal extent expressed as a number scaled by a temporal unit
type sTimeDuration struct {
	propCommon
	propTimeNumericDurationBasefloat64Typefloat64Singlefloat64
	propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit
}

// NewTimeDuration creates a new TimeDuration
func (mod *Model) NewTimeDuration(iri string) (ret TimeDuration, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sTimeDuration{}
	pc := propCommon{iri: iri, typ: "TimeDuration", model: mod}
	res.propCommon = pc
	mod.addTimeDuration(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sTimeDuration) makeMaps() {
	return
}

// addTimeDuration adds TimeDuration to model
func (mod *Model) addTimeDuration(res TimeDuration) {
	mod.mTimeDuration[res.IRI()] = res
	mod.addTimeTemporalDuration(res)
	return
}

// TimeDuration returns all resources with given prefix
func (mod *Model) TimeDuration(prefix string) (res []TimeDuration) {
	for i := range mod.mTimeDuration {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mTimeDuration[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sTimeDuration) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "http://www.w3.org/2006/time#unitType":
		res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.removeObject(obj)
	default:
	}
	return
}

// isTimeDuration indicates base class
func (res *sTimeDuration) IsTimeDuration() bool {
	return true
}

// isTimeTemporalDuration indicates base class
func (res *sTimeDuration) IsTimeTemporalDuration() bool {
	return true
}

// InitFromNode initializes the resource from a graph node
func (res *sTimeDuration) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sTimeDuration) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "http://www.w3.org/2006/time#numericDuration":
		res.propTimeNumericDurationBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#unitType":
		res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.init(res.model, pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sTimeDuration) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "http://www.w3.org/2006/time#Duration", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sTimeDuration) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propTimeNumericDurationBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sTimeDuration) String() (ret string) {
	ret = res.iri + " " + "TimeDuration\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sTimeDuration) propsString() (ret string) {
	ret = ""
	ret += res.propTimeNumericDurationBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.String()
	return
}


